<?php

function CategoryItemCompare($Item1, $Item2) 
{
  if ($Item1['Index'] == $Item2['Index']) return(0);
  return ($Item1['Index'] > $Item2['Index']) ? -1 : 1;
}

class News extends Module
{
  var $Dependencies = array('User', 'Log');
  var $NewsCountPerCategory = 3;
  var $UploadedFilesFolder = 'aktuality/uploads/';
  
  function ShowNews($Category, $ItemCount, $DaysAgo)
  {
    global $Database, $NewsCategoryNames, $NewsCountPerCategory, $UploadedFilesFolder;

    $ItemCount = abs($ItemCount);
    $DaysAgo = abs($DaysAgo);
    $DbResult = $Database->select('NewsCategory', '*', 'Id='.$Category);
    $Row = $DbResult->fetch_array();
    $Output = '<table cellspacing="0" cellpadding="0" border="0" width="100%" style="font-size: small; padding-bottom: 5px;"><tr>';
    $Output .= '<td>'.$Row['Caption'].'</td><td align="right">';
    $Output .= '<a href="aktuality/index.php?category='.$Category.'">Zobrazit všechny aktuality</a>&nbsp;';
    if($this->System->Modules['User']->CheckPermission('News', 'Insert', 'Group', $Category))
      $Output .= '<a href="aktuality/index.php?action=add&amp;category='.$Category.'">Přidat aktualitu</a>&nbsp;';
    $Output .= '</td></tr><tr><td colspan="2">';
    $DbResult = $Database->query('SELECT `News`.*, `User`.`Name` FROM `News` LEFT JOIN `User` ON `User`.`Id`=`News`.`User` WHERE (`News`.`Category`='.$Category.') AND (DATE_SUB(NOW(), INTERVAL '.$DaysAgo.' DAY) < `News`.`Date`) ORDER BY `News`.`Date` DESC LIMIT 0,'.$ItemCount);
    //echo($Database->error.'<br />');
    //echo($Database->LastQuery.'<br />');
    //echo('<table cellpadding="0" cellspacing="0" width="100%"><tr><td>');
    $Index = 0;
    $FontSize = 12;
    if($DbResult->num_rows > 0)
    {
      $Output .= '<table cellspacing="0" width="100%" class="NewsTable">';
      while($Row = $DbResult->fetch_array())
      {
        if($Row['Name'] == '') $Author = $Row['Author'];
          else $Author = $Row['Name'];
        $Output .= '<tr><td onclick="window.location=\'aktuality/index.php?action=view&amp;id='.$Row['Id'].'\'" onmouseover="zobraz('."'new".$Category.$Index."'".')" style="cursor: pointer; margin: 0px;"><table cellspacing="0" cellpadding="0" style="padding: 0px; margin: 0px; font-size: small; color: red;" width="100%"><tr><td style="font-size: '.$FontSize.'pt"><strong>'.$Row['Title'].'</strong></td><td align="right" style="font-size: '.$FontSize.'pt">'.$Author.' ('.HumanDate($Row['Date']).')</td></tr></table>';
        $Output .= '<div id="new'.$Category.$Index.'" class="NewsTableItem">'.$Row['Content'];

        if($Row['Enclosure'] != '')
        { 
          $Output .= '<br />Přílohy: ';
          $Enclosures = explode(';', $Row['Enclosure']);
 	        foreach($Enclosures as $Enclosure)
	        {
	          if(file_exists($UploadedFilesFolder.$Enclosure)) $Output .= ' <a href="'.$UploadedFilesFolder.$Enclosure.'">'.$Enclosure.'</a>';
  	      }
        }
        $Output .= '</div></td></tr>';
        $Index = $Index + 1;    
        $FontSize = $FontSize - 1;
      }
      $Output .= '</table>';
    }
    $Output .= '</td></tr></table>'."\n\n";
    return($Output);
  }

  function LoadSettingsFromCookies()
  {
    // Initialize default news setting
    $this->NewsSetting = array();
    $I = 1;
    $DbResult = $this->Database->select('NewsCategory', '*');
    while($NewsCategory = $DbResult->fetch_array())
    {
      $this->NewsSetting[] = array('CategoryId' => $NewsCategory['Id'], 'Index' => $I, 'Enabled' => 1, 'ItemCount' => $this->System->Config['Web']['News']['Count'], 'DaysAgo' => $this->System->Config['Web']['News']['DaysAgo']);
      $I++;
    }
    // Merge defaults with user setting
    if(array_key_exists('NewsSetting', $_COOKIE))
    {
      $NewsSettingCookie = unserialize($_COOKIE['NewsSetting']);
      foreach($this->NewsSetting as $Index => $this->NewSetting)
      {
        $this->NewsSetting[$Index] = array_merge($this->NewSetting, $NewsSettingCookie[$Index]);
      }
    }
  }

  function Show()
  {
    $Output = '<div class="PanelTitle"><span class="MenuItem">Aktuálně</span><div class="MenuItem2"><a href="?Action=CustomizeNews">Upravit</a></div></div>';

    $UploadedFilesFolder = 'aktuality/uploads/';
    $this->LoadSettingsFromCookies();

    if(array_key_exists('Action', $_GET))
    {
      // Show news customize menu
      if($_GET['Action'] == 'CustomizeNews')
      {
        $Output .= $this->ShowCustomizeMenu();
      }
    }

    $Output .= '<div onmouseout="skryj(predchozi)">';

    foreach($this->NewsSetting as $SettingItem)
      if($SettingItem['Enabled'] == 1) $Output .= $this->ShowNews($SettingItem['CategoryId'], $SettingItem['ItemCount'], $SettingItem['DaysAgo']);

    $Output .= '<a href="aktuality/subscription.php"><img class="RSSIcon" src="images/rss20.png" alt="Aktuality přes RSS" /></a>  <a href="aktuality/subscription.php">Automatické sledování novinek</a>';
    $Output .= '</div>';
    return($Output);
  }  

  function ShowCustomizeMenu()
  {
    $Output = '<form action="?Action=CustomizeNewsSave" method="post">';
    $Output .= '<table width="100%" cellspacing="0" border="1"><tr><td><table cellspacing="0" width="100%">';
    $Output .= '<tr><th>Kategorie</th><th>Pozice</th><th>Zobrazit</th><th>Max. počet</th><th>Posledních dnů</th></tr>';
    $I = 0;
    foreach($this->NewsSetting as $SettingItem)
    {
      $DbResult = $this->Database->select('NewsCategory', '*', 'Id='.$SettingItem['CategoryId']);
      $NewsCategory = $DbResult->fetch_array();
      $Output .= '<tr><td>'.$NewsCategory['Caption'].'</td><td align="center"><input type="text" size="2" name="NewsCategoryIndex'.$I.'" value="'.$SettingItem['Index'].'" /></td><td align="center"><input type="checkbox" name="NewsCategoryEnabled'.$I.'"';
      if($SettingItem['Enabled'] == 1) $Output .= ' checked="checked"'; 
      $Output .= ' /></td>'.
      '<td align="center"><input type="text" size="2" name="NewsCategoryCount'.$I.'" value="'.$SettingItem['ItemCount'].'" />'.
      '<input type="hidden" name="NewsCategoryId'.$I.'" value="'.$SettingItem['CategoryId'].'" /></td>'.
	  '<td align="center"><input type="text" size="3" name="NewsCategoryDaysAgo'.$I.'" value="'.$SettingItem['DaysAgo'].'" /></td></tr>';
      $I++;
    }
    $Output .= '</table><input type="hidden" name="NewsCategoryCount" value="'.count($this->NewsSetting).'" /><input type="submit" value="Uložit" /></form></td></tr></table>';
    return($Output);
  }

  function CustomizeSave()
  {
    $Checkbox = array('' => 0, 'on' => 1);
    // print_r($_POST);
    $Setting = array();
    for($I = 0; $I < $_POST['NewsCategoryCount']; $I++)
    {
      if(($_POST['NewsCategoryDaysAgo'.$I] * 1) < 0) $_POST['NewsCategoryIndex'.$I] = 0;
      if(($_POST['NewsCategoryCount'.$I] * 1) < 0) $_POST['NewsCategoryCount'.$I] = 0;
      if(!array_key_exists('NewsCategoryEnabled'.$I, $_POST)) $_POST['NewsCategoryEnabled'.$I] = '';
      $Setting[] = array('CategoryId' => $_POST['NewsCategoryId'.$I], 'Enabled' => $Checkbox[$_POST['NewsCategoryEnabled'.$I]], 'ItemCount' => ($_POST['NewsCategoryCount'.$I]*1), 'DaysAgo' => ($_POST['NewsCategoryDaysAgo'.$I]*1), 'Index' => ($_POST['NewsCategoryIndex'.$I]*1));
    }
    // Sort indexes
    usort($Setting, 'CategoryItemCompare');
    $Setting = array_reverse($Setting);
    // Normalize indexes
    foreach($Setting as $Index => $Item)
      $Setting[$Index]['Index'] = $Index + 1;
    // print_r($Setting);

    // Store new cookie value
    $_COOKIE['NewsSetting'] = serialize($Setting);
    setcookie('NewsSetting', $_COOKIE['NewsSetting'], time() + 60 * 60 * 24 * 365);
  }
}

?>
